Description

Consider this excerpt:

>>> use P := QQ[x];

--> ERROR: I was expecting a semicolon but I've found ":=" 

--> use P := QQ[x];

-->       ^^

 

The message should really say "expecting semicolon or ::=".

Or we could even allow := in this context, but that might be confusing?

History

#1 - 23 May 2019 15:13 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

The relevant source code is in Parser.C  around line 360 in the function parseUseStatement.

I think it may be reasonable to accept a normal assignment operator := but issue a warning.

No doubt the error message was produced by the call to this->expectingSemicolon; somehow we should supply a better message to be printed (e.g.

via an optional string arg?)

#2 - 01 Oct 2019 14:44 - John Abbott

- Target version changed from CoCoA-5.3.0 to CoCoA-5.4.0

#3 - 19 Mar 2021 15:38 - John Abbott

- Assignee set to John Abbott

- % Done changed from 10 to 30

I have just modified the parser to print out a warning:

/**/ use P := QQ[x];

--> WARNING: Interpreting := as ::=

--> use P := QQ[x];

-->       ^^

/**/ P;
Is this reasonable behaviour?  Should I check in?

#4 - 02 Apr 2021 10:38 - John Abbott

- Status changed from In Progress to Feedback

- % Done changed from 30 to 90

Anna approved this change during discussions.  The warning has been reworded:

/**/ use P := QQ[x];

--> WARNING: Write ::= instead of := to avoid this warning

--> use P := QQ[x];

-->       ^^

 

There was also a suggestion simply to allow := without any warning.  JAA thinks this could be confusing; Anna thought it would be easier for new

users.

We decided to accept the current impl, and possibly open a new issue in future if the warning proves to be irritating.

#5 - 16 Sep 2021 12:38 - Anna Maria Bigatti

- Status changed from Feedback to Closed

- % Done changed from 90 to 100
